/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToTraining.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToTraining.Api.Model
{
    /// <summary>
    /// Describes a training registrant.
    /// </summary>
    public class Registrant
    {
        /// <summary>
        /// The registrant's email address
        /// </summary>
        public string email { get; set; }

        /// <summary>
        /// The registrant's first name
        /// </summary>
        public string givenName { get; set; }

        /// <summary>
        /// The registrant's surname
        /// </summary>
        public string surname { get; set; }

        /// <summary>
        /// The registrant's status
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public StatusEnum? status { get; set; }

        /// <summary>
        /// The date and time the registration took place
        /// </summary>
        public DateTime? registrationDate { get; set; }

        /// <summary>
        /// The URL the registrant will use to join the training
        /// </summary>
        public string joinUrl { get; set; }

        /// <summary>
        /// The URL where the confirmation for the registration can be found
        /// </summary>
        public string confirmationUrl { get; set; }

        /// <summary>
        /// The registrant's key
        /// </summary>
        public string registrantKey { get; set; }

        /// <summary>
        /// The registrant's status
        /// </summary>
        public enum StatusEnum
        {
            /// <summary>
            ///
            /// </summary>
            WAITING,
            /// <summary>
            ///
            /// </summary>
            APPROVED,
            /// <summary>
            ///
            /// </summary>
            DENIED,
        };


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Registrant {\n");
            var emailString = email.Stringify();
            if (!string.IsNullOrEmpty(emailString))
                sb.AppendFormat("  email: {0}\n", emailString);
            var givenNameString = givenName.Stringify();
            if (!string.IsNullOrEmpty(givenNameString))
                sb.AppendFormat("  givenName: {0}\n", givenNameString);
            var surnameString = surname.Stringify();
            if (!string.IsNullOrEmpty(surnameString))
                sb.AppendFormat("  surname: {0}\n", surnameString);
            var statusString = status.Stringify();
            if (!string.IsNullOrEmpty(statusString))
                sb.AppendFormat("  status: {0}\n", statusString);
            var registrationDateString = registrationDate.Stringify();
            if (!string.IsNullOrEmpty(registrationDateString))
                sb.AppendFormat("  registrationDate: {0}\n", registrationDateString);
            var joinUrlString = joinUrl.Stringify();
            if (!string.IsNullOrEmpty(joinUrlString))
                sb.AppendFormat("  joinUrl: {0}\n", joinUrlString);
            var confirmationUrlString = confirmationUrl.Stringify();
            if (!string.IsNullOrEmpty(confirmationUrlString))
                sb.AppendFormat("  confirmationUrl: {0}\n", confirmationUrlString);
            var registrantKeyString = registrantKey.Stringify();
            if (!string.IsNullOrEmpty(registrantKeyString))
                sb.AppendFormat("  registrantKey: {0}\n", registrantKeyString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
