/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Text;
using System.Collections;
using System.Collections.Generic;
using LogMeIn.GoToTraining.Api.Common;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;


namespace LogMeIn.GoToTraining.Api.Model
{
    /// <summary>
    /// Describes a completed training session.
    /// </summary>
    public class Session
    {
        /// <summary>
        /// The key of the training session
        /// </summary>
        public string sessionKey { get; set; }

        /// <summary>
        /// The subject of the training
        /// </summary>
        public string trainingName { get; set; }

        /// <summary>
        /// The time the training session started
        /// </summary>
        public DateTime? sessionStartTime { get; set; }

        /// <summary>
        /// The time the training session finished
        /// </summary>
        public DateTime? sessionEndTime { get; set; }

        /// <summary>
        /// The number of attendees at the training session
        /// </summary>
        public int? attendanceCount { get; set; }

        /// <summary>
        /// The duration of the training session in minutes
        /// </summary>
        public int? duration { get; set; }

        /// <summary>
        /// The organizers of the training session.
        /// </summary>
        public List<Organizer> organizers { get; set; }


        /// <summary>
        /// Returns a string representing the current object.
        /// </summary>
        /// <returns>The Json serialization of the current object.</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class Session {\n");
            var sessionKeyString = sessionKey.Stringify();
            if (!string.IsNullOrEmpty(sessionKeyString))
                sb.AppendFormat("  sessionKey: {0}\n", sessionKeyString);
            var trainingNameString = trainingName.Stringify();
            if (!string.IsNullOrEmpty(trainingNameString))
                sb.AppendFormat("  trainingName: {0}\n", trainingNameString);
            var sessionStartTimeString = sessionStartTime.Stringify();
            if (!string.IsNullOrEmpty(sessionStartTimeString))
                sb.AppendFormat("  sessionStartTime: {0}\n", sessionStartTimeString);
            var sessionEndTimeString = sessionEndTime.Stringify();
            if (!string.IsNullOrEmpty(sessionEndTimeString))
                sb.AppendFormat("  sessionEndTime: {0}\n", sessionEndTimeString);
            var attendanceCountString = attendanceCount.Stringify();
            if (!string.IsNullOrEmpty(attendanceCountString))
                sb.AppendFormat("  attendanceCount: {0}\n", attendanceCountString);
            var durationString = duration.Stringify();
            if (!string.IsNullOrEmpty(durationString))
                sb.AppendFormat("  duration: {0}\n", durationString);
            var organizersString = organizers.Stringify();
            if (!string.IsNullOrEmpty(organizersString))
                sb.AppendFormat("  organizers: {0}\n", organizersString);
            sb.Append("}\n");
            return sb.ToString();
        }
    }

}
