/*
 * © 2017 LogMeIn, Inc. All Rights Reserved.
 * All rights reserved.
 * 
 * This software is distributed under the terms and conditions of the
 * LogMeIn SDK License Agreement. Please see file LICENSE for details.
 * 
 * Auto-generated file.
 */


using System;
using System.Collections.Generic;
using LogMeIn.GoToTraining.Api.Common;
using LogMeIn.GoToTraining.Api.Model;


namespace LogMeIn.GoToTraining.Api
{
    /// <summary>
    ///
    /// </summary>
    public class OrganizersApi
    {
        private string basePath = "https://api.getgo.com/G2T/rest";
        private readonly ApiInvoker apiInvoker = ApiInvoker.GetInstance();

        /// <summary>
        /// Initializes a new instance of the OrganizersApi class using the
        /// default endpoint base url for the services being accessed.
        /// </summary>
        public OrganizersApi()
        {
        }

        /// <summary>
        /// Initializes a new instance of the OrganizersApi class using an endpoint base
        /// url other than the default. Use this constructor only if you should need
        /// to override the default endpoint base url.
        /// </summary>
        /// <param name="basePath">The endpoint base url for the services being accessed.</param>
        public OrganizersApi(String basePath)
        {
            this.basePath = basePath;
        }

        /// <summary>
        /// Gets the API invoker
        /// </summary>
        public ApiInvoker Invoker
        {
            get { return apiInvoker; }
        }

        /// <summary>
        /// Gets the endpoint base url for the services being accessed
        /// </summary>
        public String BasePath
        {
            get { return basePath; }
        }

        /// <summary>
        /// DEPRECATED: Get Organizers
        /// DEPRECATED: Please use the Admin API call 'Get all users' instead. For details see https://goto-developer.logmeininc.com/get-all-users.
        /// </summary>
        /// <param name="authorization">Access token</param>
        /// <param name="accountKey">The key of the multi-user account</param>
        /// <returns>List&lt;Organizer&gt;</returns>
        /// <exception cref="ApiException"></exception>
        [Obsolete]
        public List<Organizer> getAllOrganisers(string authorization, long? accountKey)
        {
            if (authorization == null)
                throw new ApiException("Required parameter authorization is null.");

            if (accountKey == null)
                throw new ApiException("Required parameter accountKey is null.");

            // create path and map variables
            var path = "/accounts/{accountKey}/organizers"
                .Replace("{format}", "json")
                .Replace("{" + "accountKey" + "}", apiInvoker.EscapeString(accountKey.ToString()));

            // query params
            var queryParams = new Dictionary<String, String>();
            var headerParams = new Dictionary<String, String>();
            var formParams = new Dictionary<String, object>();

            headerParams.Add("Authorization", authorization);

            var contentTypes = new List<string> { "application/json" };
            string contentType = contentTypes.Count > 0 ? contentTypes[0] : "application/json";

            var response = apiInvoker.InvokeAPI(basePath, path, "GET", queryParams, null, headerParams, formParams, typeof(List<Organizer>), contentType);
            if (response != null)
                return (List<Organizer>)response;

            return null;
        }


    }
}
